"
 COPYRIGHT (c) 2010 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libcomp' }"

Method variableSubclass:#InstrumentedMethod
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'System-Compiler-Instrumentation'
!

!InstrumentedMethod class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2010 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    Instances of me are created by the instrumenting compiler.

    [author:]
        Claus Gittinger
"
! !

!InstrumentedMethod class methodsFor:'cleanup'!

cleanAllInfoWithChange:withChange
    InstrumentingCompiler::InstrumentationInfo cleanAllInfoWithChange:withChange

    "Created: / 20-07-2011 / 19:01:21 / cg"
! !

!InstrumentedMethod methodsFor:'accessing'!

blockInvocationInfo
    "return a collection of all block-info objects"

    |info|

    info := OrderedCollection new.
    self literalsDo:[:lit |
        lit isSpecialInstrumentationInfoLiteral ifTrue:[
            (lit isMemberOf:InstrumentingCompiler::BlockExecutionInfo) ifTrue:[
                info add:lit
            ]
        ]
    ].
    ^ info

    "Created: / 27-04-2010 / 13:47:21 / cg"
    "Modified: / 07-08-2011 / 17:05:02 / cg"
!

invokedViaPerform
    "true if the method is ever invoked via perform"

    |info|

    info := self methodInvocationInfo.
    ^ info notNil and:[info invokedViaPerform]

    "Created: / 27-04-2010 / 18:23:10 / cg"
!

methodInvocationInfo
    "return the collected method-invocatin info"

    ^ self 
        literalsDetect:[:lit | lit isSpecialInstrumentationInfoLiteral
                               and:[ lit isMethodInvocationInfo]] 
        ifNone:nil

    "Created: / 27-04-2010 / 13:34:01 / cg"
!

statementInvocationInfo
    |info|

    info := OrderedCollection new.
    self literalsDo:[:lit | 
        (lit isMemberOf:InstrumentingCompiler::StatementExecutionInfo) ifTrue:[
            info add:lit
        ]
    ].
    ^ info
! !

!InstrumentedMethod methodsFor:'queries'!

hasBeenCalled
    |info|

    ^ (info := self methodInvocationInfo) notNil
    and:[ info hasBeenCalled ]

    "Created: / 27-04-2010 / 13:03:33 / cg"
!

haveAllBlocksBeenExecuted
    ^ self blockInvocationInfo conform:[:eachBlockInfo | eachBlockInfo callCount > 0]

    "Modified: / 27-04-2010 / 13:44:46 / cg"
!

isInstrumented
    ^ true

    "Created: / 27-04-2010 / 12:25:39 / cg"
! !

!InstrumentedMethod class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/libcomp/InstrumentedMethod.st,v 1.6 2011-08-08 18:09:07 cg Exp $'
! !
